#!/usr/bin/perl

use World;
use MUD;
use POSIX;

print "starting Bedlam...\n";

my $pidfile = '/var/run/bedlam.pid';


if (-e $pidfile)
{
 my $oldpid;

 open(PF, "<$pidfile");
 while(<PF>)
 {
  ($oldpid) = $_;
  chomp($oldpid);
 }

 close(PF);

 if ($oldpid)
 {
  my $running = kill 0, $oldpid;
  if ($running)
  {
   die "Another instance is already running!";
  }
 }
}

#detach

$pid = fork;
exit if $pid;
die "Could not fork!: $!" unless defined($pid);

POSIX::setsid() or die "Cannot start a new session!: $!";


# announce our presence

die "cant open pidfile: $!" unless open(PF,">$pidfile");

print PF "$$\n";

close(PF);

 


my $world = World->new();
World->load_world_objects($world);

my $mud = MUD->new();


