package Events;

use strict;
no strict 'refs';
use vars qw($AUTOLOAD);
use Carp;


sub new  {
    my ($class_name) = @_;
    my $self = {};

    bless ($self, $class_name);
    Utility->log(1,'events',"new class");
    return $self;
}

sub DESTROY { }  # Does this work???

sub AUTOLOAD {
        my $self = shift;
        my $name = $AUTOLOAD;
        $name =~ s/.*:://;

        Utility->log(1,'events',"no code to handle event '$name'");
}




# nurse in electroshock room, takes green key and send player home

sub electroshock
{
 my $char = shift;
 my $victim = shift;

 Utility->log(1,'events','Electroshock therapy for '.  $victim->id() . ' courtesy of ' . $char->id());

 $victim->tell_user("\"You're not cooperating...\", says the nurse as she lunges across the room and tackles you.  She drags you to the couch and straps you in.  Then she pulls an ominous lever and you experience the ultimate agony!  Mercifully, you pass out...\nYou awaken in your cell.");

 if (World->get_object('greenkey')->location() eq $victim->id())
 {
  World->get_object('greenkey')->go_home();
 }

 $victim->set_location('cell01');
# $char->forget($victim);
 World->get_object('greendoor2')->closed(1); 
}




# doctor gives a lobotomy

sub lobotomy
{
 my $char = shift;
 my $victim = shift;

 
 Utility->log(1,'events','Lobotomy for '.  $victim->id() . ' courtesy of ' . $char->id());

 $victim->tell_user("The doctor says, \"I'm afraid I'm going to have to give you a frontal lobotomy!\"  He sticks you with his hypo and you pass out.\nWhen you awaken, you feel somewhat indifferent about your surroundings.  You notice blood on your gown, but it doesn't seem to bother you.\nYou feel like wandering...");

 $victim->set_location('cell01');
 $victim->mobile(1);
 World->get_object('greendoor2')->closed(1);
}



# meat falls out

sub open_frig
{
 my $object = shift;
 my $actor = shift;

 if (World->get_object('meat')->location() eq $object->id())
 {
  Utility->log(1,'events','The meat is falling out of the frig for ' . $actor->id()); 
 
  $actor->tell_user("When you open the refrigerator, some hamburger meat falls out of it onto the floor.");
  World->get_object('meat')->set_location($actor->location());
 }
}


sub put_pill
{
 my $object = shift;
 my $actor = shift;
 my $target = shift;

 Utility->log(7,'events','blue pill put');

 if ($target->id() eq 'meat')
 {
  Utility->log(1,'events',$actor->id() . " puts the blue pill in the meat");
  $actor->tell_user("The pill seems to dissolve in the hamburger.");
  World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " puts the blue pill in the hamburger and patiently watches it dissolve.");
  $object->location('meat');
 }
 else
 {
  $actor->tell_user("The blue pill won't fit in " . $target->name() . ".");
  World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " fails to put the blue pill in " . $target->name() . ".");
 }

}


sub houdini_untie
{
 my $object = shift;
 my $actor = shift;

 Utility->log(7,'events',$actor->id() . ' frees Houdini');

 $object->load_state('freed');
}


sub feed_dog
{
 my $object = shift;
 my $actor = shift;

 Utility->log(7,'events',$actor->id() . ' feeds the dog');


 $actor->tell_user('The dog wolfs down the hamburger. He must be pretty hungry!');
 World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " feeds the hamburger to the dog, who wolfs it down.");
 
 # TODO check for game win type

 if (World->get_object('bluepill')->location() eq 'meat')
 {
  $actor->tell_user("The dog looks sick. He weaves and falls over dead.");  
  World->get_object($actor->location())->tell_rest_of_room($actor,"The dog looks sick. He weaves and falls over dead.");
 
  World->get_object('dogdenies')->locked(0);
  World->get_object('dogdenies')->closed(0);     
  World->get_object('dog')->load_state('dead');
 }
 
}


sub xray_open
{
 my $actor = shift;
 my $objectsref = shift;
 my $leftoversref = shift;

 $actor->tell_user("Ray makes a feeble attempt and then draws back.  \"Sorry, I've been rather anemic lately!\"");
}


sub bus_beat
{
 my $self = shift;
 my $tmp;
 my $itmp;
 my $do_move = 0;

 $self->{attr}->{beats}++;

 if ($self->travelling() == 0)
 {

  if ($self->{attr}->{beats} == 3)
  {
   World->get_object($self->location())->tell_room("A loudspeaker mounted on top of the Sunnyvale MTD bus announces, \"The bus will be leaving shortly.  All aboard!\"");
   $self->tell_room("The driver announces that the bus will be leaving soon.");
  }
  elsif ($self->{attr}->{beats} == 5)
  {
   if ($self->location() eq 'street1')
   {
    $tmp = "The engine roars as the Sunnyvale MTD bus pulls away from the curb and heads down the street.";
    $itmp = "The driver announces, \"We're off!  We should be at our next stop in just a few minutes.\"\nWith a roar of the engines, the driver pulls away from the curb.";
   }
   else
   {
    $tmp = "The Sunnyvale MTD bus closes it's door with a hiss of air.  The driver beeps the horn as the bus pulls into the road and heads to it's next destination.";
    $itmp = "The driver announces, \"Ok folks, we should arrive at our next stop in just a couple minutes.\"\nThe driver honks the horn twice and pulls out into the street.";
   }
  
   World->get_object($self->location())->tell_room($tmp);
   $self->tell_room($itmp);

   $self->{attr}->{beats} = 0;
   $do_move = 1;
  }
 }
 else
 {
  if ($self->{attr}->{beats} == 3)
  {
   $self->{attr}->{beats} = 0;
   $do_move = 1;
  }
 }

 if ($do_move)
 {
  if ($self->location() eq 'street1')
  {
   $self->location('road1to2');
   $self->locked(1);
   $self->travelling(1);
  }
  elsif ($self->location() eq 'road1to2')
  {
   $self->locked(0);
   $self->travelling(0);
   $self->location('street2');
   World->get_object('street2')->tell_room("A Sunnyvale MTD bus pulls to a stop at the side of the road.  A display on the front reads \"Next stop: Pyramid\".");
  }
  elsif ($self->location() eq 'street2')
  {
   $self->locked(1);
   $self->travelling(1);
   $self->location('road2to3');
  }
  elsif ($self->location() eq 'road2to3')
  {
   $self->locked(0);
   $self->travelling(0);
   $self->location('street3');
   World->get_object('street3')->tell_room("A Sunnyvale MTD bus pulls to a stop at the side of the road.  A display on the front reads \"Next stop: Sunnyvale\".");
  }
  elsif ($self->location() eq 'street3')
  {
   $self->locked(1);
   $self->travelling(1);
   $self->location('road3to1');
  }
  elsif ($self->location() eq 'road3to1')
  {
   $self->locked(0);
   $self->travelling(0);
   $self->location('street1');
   World->get_object('street1')->tell_room("A Sunnyvale MTD bus pulls up to the curb.  A display on the front reads \"Next stop: Jungle\".");
  }
 }


}


1;

