#!/usr/bin/perl

use GameConfig;
use World;
use MUD;
use POSIX;

print "starting the game...\n";

my $config = GameConfig->new();

my $pidfile = $config->{'PIDFILE'};


if (-e $pidfile)
{
 my $oldpid;

 open(PF, "<$pidfile");
 while(<PF>)
 {
  ($oldpid) = $_;
  chomp($oldpid);
 }

 close(PF);

 if ($oldpid)
 {
  my $running = kill 0, $oldpid;
  if ($running)
  {
   die "Another instance is already running!";
  }
 }
}

#detach

if ($config->{'DETACH'})
{

 $pid = fork;
 exit if $pid;
 die "Could not fork!: $!" unless defined($pid);

 POSIX::setsid() or die "Cannot start a new session!: $!";
}


# announce our presence

die "cant open pidfile: $!" unless open(PF,">$pidfile");

print PF "$$\n";

close(PF);

 


my $world = World->new();
World->load_world_objects($world);
my $mud = MUD->new();


