package Noun;

use strict;
no strict 'refs';
use Carp;
use base 'Object';


sub new  {
        my $class = shift;
        my $id = shift;

        my $self = $class->SUPER::new($id);

        bless ($self, $class);

        return $self;
}


sub DESTROY
{
 my $self = shift;


}


sub set_location
{
 my $self = shift;
 my $location = shift;

 if (World->valid_object($location))
 {
  $self->location($location);
  $self->commands_in_room(0);

  Utility->log(7,'noun',"set location for " . $self->id() . " to $location");
 }
 else
 {
  Utility->log(1,'noun',"failed to set location for " . $self->id() . " to nonexistant location $location");
 }
}




sub open_attempt
{
 my $self = shift;
 my $actor = shift;

 if ($self->closable())
 {

  if ($self->closed())
  {
   if ($self->locked())
   {
    if ($self->is_message('locked'))
    {
     $actor->tell_user($self->message('locked'));
    }
    else
    {
     $actor->tell_user(ucfirst($self->name()) . " is locked.");
    }

    if ($self->is_message('olocked'))
    {
     World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name . " " . $self->message('olocked'));
    }
    else
    {
     World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name . " fails to open " . $self->name() . ".");
    }

   }
   else
   {
    $self->closed(0);

    if ($self->is_message('on_open'))
    {
     $actor->tell_user($self->message('on_open'));
    }
    else
    {
     $actor->tell_user(ucfirst($self->name()) . " is now open.");
    }
 
    if ($self->is_message('oon_open'))
    {
     World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " " . $self->message('oon_open'));
    }
    else
    {
     World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " opens " . $self->name() . ".");
    }

    if (defined $self->{attr}->{on_open_hook})
    {
     Utility->log(7,'noun','open hook for ' . $self->id() . ":" . $self->{attr}->{on_open_hook});
     &{$self->{attr}->{on_open_hook}}($self,$actor);
    }

   }
  }
  else
  {
   $actor->tell_user(ucfirst($self->name()) . " is already open.");
  }
 }
 else
 {
  $actor->tell_user("You can't do that to " . $self->name() . ".");
 }
}


sub close_attempt
{
 my $self = shift;
 my $obj = shift;

 if ($self->closable())
 {

  unless ($self->closed())
  {
   if ($self->locked())
   {
    if ($self->is_message('locked'))
    {
     $obj->tell_user($self->message('locked'));
    }
    else
    {
     $obj->tell_user(ucfirst($self->name()) . " is locked.");
    }

    if ($self->is_message('olocked'))
    {
     World->get_object($obj->location())->tell_rest_of_room($obj,$obj->name . " " . $self->message('olocked'));
    }
    else
    {
     World->get_object($obj->location())->tell_rest_of_room($obj,$obj->name . " fails to close " . $self->name() . ".");
    }

   }
   else
   {
    $self->closed(1);

    if ($self->is_message('on_close'))
    {
     $obj->tell_user($self->message('on_close'));
    }
    else
    {
     $obj->tell_user(ucfirst($self->name()) . " is now closed.");
    }

    if ($self->is_message('oon_close'))
    {
     World->get_object($obj->location())->tell_rest_of_room($obj,$obj->name() . " " . $self->message('oon_close'));
    }
    else
    {
     World->get_object($obj->location())->tell_rest_of_room($obj,$obj->name() . " closes " . $self->name() . ".");
    }
   }
  }
  else
  {
   $obj->tell_user(ucfirst($self->name()) . " is already closed.");
  }
 }
 else
 {
  $obj->tell_user("You can't do that to " . $self->name() . ".");
 }
}



sub take_attempt
{
 my $self = shift;
 my $actor = shift;
 my $tool = shift;

 if ($self->location() eq $actor->id())
 {
  $actor->tell_user("You already have " . $self->name . ".");
  return();
 }

 if ($self->is_phantom_at($actor->location()))
 {
  $actor->tell_user("You cannot take " . $self->name . " from out here.");
  return();
 }

 

 if ($self->takeable())
 {
  if (World->get_object($self->location())->locked())
  {
   if (defined $tool)
   {
    if (World->get_object($self->location())->key() eq $tool->id())
    {
     $self->location($actor->id());

     if ($self->is_message('taken_with_' . $tool->id()))
     {
      $actor->tell_user($self->message('taken_with_' . $tool->id()));
     }
     else
     {
      $actor->tell_user(ucfirst($self->name()) . " taken.");
     }

     World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " takes " . $self->name() . ".");
    }
    else
    {
     $actor->tell_user("You can't get " . $self->name() . " with " . $tool->name() . ".");
    }  
   }
   else
   {
    if (World->get_object($self->location())->is_message('take_contents_fail'))
    {
     $actor->tell_user(World->get_object($self->location())->message('take_contents_fail'));
    }
    else
    {
     $actor->tell_user("You cannot remove " . $self->name() . " from " . World->get_object($self->location())->name());
    }
   }
  }
  else
  {
   if ($self->location() eq $actor->id())
   {
    $actor->tell_user("You already have " . $self->name() . ".");
   }
   else
   {
    $self->location($actor->id());

    $actor->tell_user(ucfirst($self->name()) . " taken.");
    World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " takes " . $self->name() . "."); 
   }
  }
 }
 else
 {
  if ($self->is_message('take_fail'))
  {
   $actor->tell_user($self->message('take_fail'));
  }
  else
  {
   $actor->tell_user("You are quite incapable of removing " . $self->name() . ".");
  }

  if ($self->is_message('otake_fail'))
  {
   World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " " . $self->message('otake_fail'));
  }
  else
  {
   World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " fails to take " . $self->name() . ".");  
  }
 }

}



sub drop_attempt
{
 my $self = shift;
 my $actor = shift;

 if ($self->location() ne $actor->id())
 {
  $actor->tell_user("You don't have it!");
  return();
 }


 if ($self->is_message('on_drop'))
 {
  $actor->tell_user($self->message('on_drop'));
 }
 else
 {
  $actor->tell_user("Dropped.");
 }
 
 if ($self->is_message('oon_drop'))
 {
  World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " " . $self->message('oon_drop'));
 }
 else
 {
  World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " drops " . $self->name() . ".");
 }

 $self->location($actor->location());
}




sub put_attempt
{
 my $self = shift;
 my $actor = shift;
 my $target = shift;

 if ($self->location() ne $actor->id())
 {
  $actor->tell_user("You don't have " . $self->name() . "!");
  return();
 }

 if (defined $target)
 {
  if ($target->container() == 1)
  {  

   unless ($target->can_contain($self))
   {
    $actor->tell_user(ucfirst($self->name()) . " won't fit in " . $target->name() . ".");
    World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " fails to fit " . $self->name() . " into " . $target->name() . "."); 
    return();
   }

   if (defined $self->{attr}->{on_put_hook})
   {
    &{$self->{attr}->{on_put_hook}}($self,$actor,$target);
   }
   else
   {

    if ($self->is_message('on_put'))
    {
     $actor->tell_user($self->message('on_put'));
    }
    else
    {
     $actor->tell_user("you put " . $self->name() . " into " . $target->name() . ".");
    }

    if ($self->is_message('oon_drop'))
    {
     World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " " . $self->message('oon_drop'));
    }
    else
    {
     World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " puts " . $self->name() . " into " . $target->name() . ".");
    }

    $self->location($target->id());
   }
  }
  else
  {
   $actor->tell_user(ucfirst($self->name()) . " won't fit in " . $target->name() . ".");
   World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " fails to fit " . $self->name() . " into " . $target->name() . ".");
  }
 }
 else
 {
  $actor->tell_user("Put " . $self->name() . " where?");
 }
}




sub eat_attempt
{
 my $self = shift;
 my $actor = shift;

 if ($self->is_message('on_eat'))
 {
  $actor->tell_user($self->message('on_eat'));
 }
 else
 {
  $actor->tell_user("Don't be silly!  " . ucfirst($self->name()) . " wouldn't taste good anyway.");
 }
 
 if ($self->is_message('oon_eat'))
 {
  World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " " . $self->message('oon_eat'));
 }
 else
 {
  World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " considers eating " . $self->name() . ", but decides that's a silly idea.");
 }

 if ($self->{attr}->{consumed} == 1)
 {
  $self->location('controlroom');
 }

}


sub untie_attempt
{
 my $self = shift;
 my $actor = shift;

 if ($self->is_message('on_untie'))
 {
  $actor->tell_user($self->message('on_untie'));
 }
 else
 {
  $actor->tell_user("You untie " .$self->name() . ".");
 }

 if ($self->is_message('oon_untie'))
 {
  World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " " . $self->message('oon_untie'));
 }
 else
 {
  World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " unties " . $self->name() . ".");
 }
 
 $self->untieable(0);
 if (defined $self->{attr}->{on_untie_hook})
 {
  &{$self->{attr}->{on_untie_hook}}($self,$actor);
 }

}




sub unlock_attempt
{
 my $self = shift;
 my $actor = shift;
 my $tool = shift;

 if ($self->lockable())
 {
  if ($self->locked())
  {
   if ($tool->id() eq $self->key())
   {
    $self->locked(0);
    $actor->tell_user(ucfirst($self->name()) . " is now unlocked.");
    World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " unlocks " . $self->name() . " with " . $tool->name() . ".");
   }
   else
   {
    $actor->tell_user("You can't unlock " . $self->name() . " with " . $tool->name() . ".");
    World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " fails to unlock " . $self->name() . " with " . $tool->name() . ".");
   }
  }
  else
  {
   $actor->tell_user(ucfirst($self->name()) . " is not locked.");
   World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " tries to unlock " . $self->name() . " but is suprised to find that it is not locked.");
  }
 }
 else
 {
  $actor->tell_user("You can't do that to " . $self->name() . ".");
  World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " tries to unlock " . $self->name() . "... how silly!");
 }
}



sub feed_attempt
{
 my $self = shift;
 my $actor = shift;
 my $target = shift;

 if ($target->location() eq $actor->id())
 {
  if (($self->type() eq 'Character') || ($self->type() eq 'Player'))
  {
   if ($self->hungry_for($target->id()))
   {
    if (defined $self->{attr}->{on_feed_hook})
    {
     &{$self->{attr}->{on_feed_hook}}($target,$actor);
    }
    else
    {
     $actor->tell_user(ucfirst($self->name()) . " eats the " . $target->name() . ".");
     World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " feeds " . $target->name() . " to " . $self->name() . ".");
    }
    $target->location($self->id());
   }
   else
   {
    $actor->tell_user(ucfirst($self->name()) . " isn't hungry right now.");
   }
  }
  else
  {
   $actor->tell_user("If you can find a mouth, I'm game!");
  }
 }
 else
 {
  $actor->tell_user("You don't have " . $target->name() . ".");
 }
}




sub look_at
{
 my $self = shift;

 my $txt = "There's nothing special about " . $self->name() . ".";

 if ($self->is_message('look_at')) { $txt = $self->message('look_at'); }

 return($txt);
}



sub home
{
 my $self = shift;
 my $objid = shift;

 $self->location($objid);
 $self->{attr}->{home} = $objid;
}



sub add_random_home                  
{
 my $self = shift;
 my $homeid = shift;

 push(@{$self->{attr}->{random_homes}},$homeid);
}


sub go_home
{
 my $self = shift;

 Utility->log(2,'noun',"Sending " . $self->id() . " home...");

 if (defined $self->{attr}->{random_homes})
 {
  my $home = ${$self->{attr}->{random_homes}}[rand @{$self->{attr}->{random_homes}}];
  $self->set_location($home);
 }
 elsif (defined $self->{attr}->{home}) 
 {
  $self->set_location($self->{attr}->{home});
 }

}


sub add_phantom_loc
{
 my $self = shift;
 my $phantomplace = shift;
 my $realplace = shift;

 ${$self->{attr}->{phantom_locs}}{$phantomplace} = $realplace;

}


sub is_phantom_at
{
 my $self = shift;
 my $objid = shift;

 foreach my $locid (keys %{$self->{attr}->{phantom_locs}})
 {

  # passed loc is a phantom loc, and current self loc is corresponding
  if (($objid eq $locid) && (${$self->{attr}->{phantom_locs}}{$locid} eq $self->location()))
  {
   return(1);
  }
 }
 
 return(0);
}


sub can_contain
{
 my $self = shift;
 my $object = shift;

 my $allowed = 0;

 if (defined $self->{attr}->{allowable_contents})
 {
print "object has ac list\n";
  foreach my $ao (@{$self->{attr}->{allowable_contents}})
  {
   if ($object->id() eq $ao)
   {
    $allowed = 1;
   }
  }
 }
 else
 {
  $allowed = 1;
 }

 return($allowed);
}


sub add_allowable_content
{
 my $self = shift;
 my $objid = shift;

 push(@{$self->{attr}->{allowable_contents}},$objid);
}



sub enter_attempt
{
 my $self = shift;
 my $actor = shift;
 my $tool = shift;

 my $amsg;
 my $omsg;

 if ($self->locked())
 {
  unless ($tool->id() eq $self->key())
  {
   if ($self->is_message('fail_enter'))
   {
    $amsg = $self->message('fail_enter');
   }
   else
   {
    $amsg = "You cannot enter " . $self->name() . " because it is locked.";
   }

   if ($self->is_message('ofail_enter'))  
   {
    $omsg = $self->message('ofail_enter');
   }
   else
   {
    $omsg = ucfirst($actor->name()) ."  fails to enter " . $self->name() . " because it is locked.";
   }

   $actor->tell_user(ucfirst($self->name()) . " is locked.");
   World->get_object($actor->location())->tell_rest_of_room($actor,$actor->name() . " fails to enter " . $self->name() . " because it is locked.");
   return;
  }
 }

 if ($self->is_message('on_enter'))
 {
  $amsg = $self->message('on_enter');
 }
 else
 {
  $amsg = "You enter " . $self->name() . ".";
 }

 if ($self->is_message('oon_enter'))
 {
  $omsg = $self->message('oon_enter');
 }
 else
 {
  $omsg = ucfirst($actor->name()) ." enters " . $self->name() . ".";
 }

 $actor->tell_user($amsg);
 World->get_object($actor->location())->tell_rest_of_room($actor,$omsg);

 $actor->set_location($self->id());
}

sub exit_attempt
{
 my $self = shift; 
 my $actor = shift;
 my $tool = shift;

 my $amsg;
 my $omsg;

 if ($self->locked()) 
 {
  if ($self->is_message('fail_exit'))
  {
   $amsg = $self->message('fail_exit');
  }
  else
  {
   $amsg = "You cannot exit " . $self->name() . " because it is locked.";
  }

  if ($self->is_message('ofail_exit'))
  {
   $omsg = $self->message('ofail_exit');
  }
  else
  {
   $omsg = ucfirst($actor->name()) ."  fails to exit " . $self->name() . " because it is locked.";
  }

  $actor->tell_user($amsg);
  World->get_object($actor->location())->tell_rest_of_room($actor,$omsg);

  return;
 }

 if ($self->is_message('on_exit'))
 {
  $amsg = $self->message('on_exit');
 }
 else
 {
  $amsg = "You exit " . $self->name() . ".";
 }

 if ($self->is_message('oon_exit'))
 {
  $omsg = $self->message('oon_exit');
 }
 else
 {
  $omsg = ucfirst($actor->name()) ." exits " . $self->name() . ".";
 }

 $actor->tell_user($amsg);
 World->get_object($actor->location())->tell_rest_of_room($actor,$omsg);

 $actor->set_location($self->location());
}



sub description_from_inside
{
 my $self = shift;
 my $obj = shift;

 my $txt;

 if (defined $self->{attr}->{style})
 {
  if ($self->style() eq 'mud')
  {
   $txt = "\n" . $self->name() . "\n";

   if ($self->is_message('inside_description'))
   {
    $txt .= $self->message('inside_description') . "\n";
   }
   else
   {
    $txt .= $self->description() . "\n";
   }

   foreach my $item (World->get_objects_at($self->id()))
   {
    if ($item->id() ne $obj->id())
    {
     $txt .= $item->description() . "\n";
    }
   }

   $txt .= "Obvious exits:\n";

   foreach my $exit (keys %{$self->{attr}->{exits}})
   {
    $txt .= $exit . "  ";
   }
   $txt .= "\n";
  }
 }
 else
 {
  if ($self->is_message('inside_description'))
  {
   $txt = $self->message('inside_description');
  }
  else
  {
   $txt = $self->description();
  }

  foreach my $exit (keys %{$self->{attr}->{exits}})
  {
   if (defined $self->{attr}->{exits}->{$exit}->{doorid})
   {
    if (World->get_object( $self->{attr}->{exits}->{$exit}->{doorid})->visible())
    {
     $txt .= "  On the $exit wall there is a " . World->get_object($self->{attr}->{exits}->{$exit}->{doorid})->color() . " door";
     if (World->get_object($self->{attr}->{exits}->{$exit}->{doorid})->closed())
     {
      $txt .= " which is closed.";
     }
     else
     {
      $txt .= ".";
     }
    }
   }
  }



  foreach my $item (World->get_objects_at($self->id()))
  {
   if ($item->type() ne 'Player')
   {
    if (defined $item->{attr}->{first_look})
    {
     if ($item->sightings($obj))
     {
      $txt .= "  " . $item->description();
     }
     else
     {
      $txt .= "  " . $item->first_look();
     }
    }
    else
    {
     $txt .= "  " . $item->description();
    }
   }
  }

  foreach my $item (World->get_objects_at($self->id()))
  {
   if (($item->type() eq 'Player') && ($item->id() ne $obj->id()))
   {
    $txt .= "\n" . $item->description();
   }
  }
 }

 return($txt);
}







1;

