package Player;

use strict;
no strict 'refs';
#use vars qw(@ISA);
#@ISA = qw(Object);  
use base 'Character';

my $config = GameConfig->new();


sub new  
{
 my $class = shift;
 my $id = shift;

 my $self = $class->SUPER::new($id);

 bless ($self, $class);

 return $self;
}




##########################################################################


sub login {
        my $class = shift;
        my ($kernel,$heap,$session,$login) = @_;
        my ($here, $k, $v);
        my $address = $heap->{address};
        my $input = Utility->filter_input($login);  # filter the input



        # get rid of fullstop before login name for kmuddy
        my $eh = substr($input,0,1);
        #print "CHARACTER:".ord($eh)."\n";

        if ($input eq "") {
                $kernel->call($session, "hear", "Invalid name. Please try again.");
                $kernel->call($session, "prompt", "Your name?: ");
        # if quit or exit
        } elsif ($input eq "quit" || $input eq "exit") { # respond to quit
                delete $heap->{readwrite};

        } elsif (($input =~ m/^GET\s\/\sHTTP.*/i) || ($input =~ m/.*\:.*/))
        {
         # somebody is using a web browser?  this doesnt work
#         $kernel->call($session, "hear", "To play the game, please use a telnet client to connect.  Web browers are currently not supported.\n");
#         $kernel->call($session, "hear", "You may be able to connect using the following url:\n");
#         $kernel->call($session, "hear", "telnet://www.groupunix.com:6809");
#         $kernel->call($session, "hear", "\nAlternately, you may be able to use the following command:\n");
#         $kernel->call($session, "hear", "telnet www.groupunix.com 6809\n"); 
        delete $heap->{readwrite};
        } else {  
                my $self = Player->new("_$input");                       # BAD?
                $self->name($input);                               # initialize player obj values
                $self->kernel($kernel);
                $self->heap($heap);
                $self->session($session);
                $self->address($address);
                $self->textwrap(76);
                $self->description("$input is here.");
                Utility->add("sessions",$session,$self);                # store session info
                $self->onsince(time);
                $self->prompt("");
                $self->tell_user("\n\nConnecting as " . $self->name() . ".  Type /help for help.\n\n");
                $self->home($config->{'PLAYERSTART'});
                World->get_object($config->{'PLAYERSTART'})->annouce_arrival($self,'connect');
                $self->prompt_user($self->prompt());                        
                $self->status("ingame");                          # set user status
                $self->mobile(0);
                $self->mobile_chance(100);
                $self->locked(1);
                $self->go_to(\&Commands::parser);              # send user input to init method
                return($self);

        }
}


sub quit
{
 my $self = shift;

 my $id = $self->id();
 my $name = $self->name();

 my $heap = $self->heap();
 my $kernel = $self->kernel();
 my $session = $self->session();
 if (Utility->check("sessions",$session)) {
                $kernel->call($session, "hear", "Goodbye $name, thanks for playing.\n");
                $kernel->call($session, "_stop");
                Utility->log(1,'player',"CLIENT: ".$self->name()." disconnected.");
                Utility->inform(ucfirst($self->name()).' has left the game.');
                Utility->del("sessions",$session);
        }
 delete $heap->{readwrite};

 World->delete_object($id);
}


sub prompt_user {
        my $self = shift;
        my $what = join('', @_);
        my $kernel = $self->kernel();
        my $session = $self->session();

        Utility->log(8,'player',"PROMPT_USER->self: $self what: $what");

        $kernel->call($session, "prompt", $what);
}


# output a message to a single user - includes lf/cr
sub tell_user {
        my $self = shift;
        my $what = Utility->wrap($self->textwrap(),@_);
        my $kernel = $self->kernel();

        Utility->log(8,'player',"TELL_USER->self: $self session: ".$self->session()." what: $what");

        $kernel->call($self->session(), "hear", $what);
}


sub tell_room {
        my $self = shift;
        my ($message, @except) = @_;
        my (%exceptions);
       # my $here = Utility->find_place($self->check("attributes","location"));
       # my %occupants = %{$here->ret_occupants()};

        my %occupants = %{Utility->reference("sessions")}; 

        foreach (@except) {$exceptions{$_} = 1}
        foreach (keys %occupants) {
                my $other = $occupants{$_};
                if (!exists $exceptions{$other->name()}) {$other->tell_user($message)}
        }
        return 1;
}


sub get_zone
{
 my $self = shift;

 my $zo = World->get_object($self->location());
 if (defined ($zo->zone()))
 {
  return(World->get_object($zo->zone()));
 }
 else
 {
  return(World->get_object('void'));
 }
}



1;

