package Verb;

use strict;
no strict 'refs';
use base 'Object';


use Data::Dumper;


sub new  {
        my $class = shift;
        my $id = shift;

        my $self = $class->SUPER::new($id);

        bless ($self, $class);

	$self->{admin} = 1;
	$self->{code} = \&Commands::noop;
	$self->{uses} = 0;
	$self->{last_user} = '';

        return $self;
}


sub admin
{
 my $self = shift;
 my $admin = shift;

 if (defined $admin)
 {
  $self->{admin} = $admin;
 }

 return($self->{admin});
}


sub code
{
 my $self = shift;
 my $code = shift;

 if (defined $code)
 {
  $self->{code} = $code;
 }

 return($self->{code});
}


sub uses
{
 my $self = shift;

 return($self->{uses});
}

sub last_user
{
 my $self = shift;

 return($self->{last_user});
}


sub classic
{
 my $self = shift;
 my $classic = shift;

 if (defined $classic)
 {
  $self->{classic} = $classic;
 }

 return($self->{classic});
}


sub is_phantom_at
{
 return(1);
}

sub command
{
 my $self = shift;
 my $actor = shift;
 my $objsref = shift;
 my $leftoversref = shift;

 World->get_object($self->location())->tell_room($self->id() . " processes a command from " . $actor->name());
 $self->{uses}++;
 $self->{last_user} = $actor->id(); 

 if ($self->is_message('blanket_response'))
 {
  $actor->tell_user($self->message('blanket_response'));
 }
 elsif (defined $self->{code})
 {
  &{$self->code()}($actor,$objsref,$leftoversref);
 }

}


1;

