#!/usr/bin/perl

use Bit::Vector;

use Memory;
use CPU;

use constant {
        FLAG_E          => 7,
        FLAG_F          => 6,
        FLAG_H          => 5,
        FLAG_I          => 4,
        FLAG_N          => 3,
        FLAG_Z          => 2,
        FLAG_V          => 1,
        FLAG_C          => 0,
        IRQ_NORMAL      => 0,
        IRQ_SYNC        => 1,
        IRQ_CWAI        => 2
};



my $mem = Memory->new();
my $cpu = CPU->new();

$offset = 0;
$initaddr = 0;


# load memory

$counter = $offset;

if (open (FH, "<$ARGV[0]"))
{
 undef $/;
 my $buffer = <FH>;
 $/ = "\n";
 close FH;

 for (my $x=0;$x<length($buffer);$x++)
 {
  $mem->set(Bit::Vector->new_Dec(16,$counter), Bit::Vector->new_Dec(8,ord(substr($buffer,$x,1))));
  $counter++;
 }
}
else
{
 die "Can't open $ARGV[0]: $!\n";
}

print "\nLoaded $counter bytes in memory at $offset\n\n";

#$mem->dump_dec(0,$counter);


$cpu->dump_cc();

$cpu->set_cc(FLAG_E,1);
$cpu->set_cc(FLAG_Z,1);
$cpu->set_cc(FLAG_C,1);

$cpu->dump_cc();


# execute

# ?

