package Memory;

use strict;
use Bit::Vector;

sub new  {
        my $class = shift;
 
        my $self = {};

        bless ($self, $class);   

	for (my $x = 0;$x < 65535;$x++)
        {
         push(@{$self->{mem}},0);
        }

        return $self;
}


sub set 
{
 my $self = shift;
 my $addr = shift;
 my $val = shift;

 @{$self->{mem}}[$addr->to_Dec()] = $val->to_Dec();
}

sub get
{
 my $self = shift;
 my $addr = shift;

 if (defined $addr)
 {
  return( Bit::Vector->new_Dec(8,@{$self->{mem}}[ $addr->to_Dec() ]));
 }
 else
 {
  print "Memory: invalid address\n";
  return( Bit::Vector->new_Dec(8,0));
 }
}


sub set16
{
 my $self = shift;
 my $addr = shift;
 my $val = shift;

 
 @{$self->{mem}}[$addr->to_Dec()] = Bit::Vector->new_Bin(8,substr($val->to_Bin(),0,8))->to_Dec;
 @{$self->{mem}}[$addr->to_Dec() + 1] = Bit::Vector->new_Bin(8,substr($val->to_Bin(),8,8))->to_Dec; 
}

sub get16
{
 my $self = shift;
 my $addr = shift;

 if (defined $addr)
 {
  my $a = Bit::Vector->new_Dec(8, @{$self->{mem}}[ $addr->to_Dec() ]);
  my $b = Bit::Vector->new_Dec(8, @{$self->{mem}}[ $addr->to_Dec() + 1 ]);
  return( Bit::Vector->new_Bin(16, $a->to_Bin() . $b->to_Bin));
 }
 else
 {
  print "Memory: invalid address\n";
  return( Bit::Vector->new_Dec(16,0));
 }
}





sub dump_dec
{
 my $self = shift;
 my ($start,$stop) = @_;

 for (my $x = $start;$x <= $stop;$x = $x + 32)
 {
  printf("%-5s", Bit::Vector->new_Dec(16,$x)->to_Hex());
  for (my $y = 0;$y < 32;$y++)
  {
#   print $mem->get($x + $y);
   print $self->get( Bit::Vector->new_Dec(16,$x + $y))->to_Hex();
   print " ";
  }
  print "\n";
 }
}


1;

