#!/usr/bin/perl

use Bit::Vector;

$a = Bit::Vector->new_Hex(8,'0');
$b = Bit::Vector->new_Hex(8,'0');

$da = Bit::Vector->new_Hex(8,'11');
$db = Bit::Vector->new_Hex(8,'00');
$dc = Bit::Vector->new_Hex(8,'00');
$dd = Bit::Vector->new_Hex(8,'00');
$de = Bit::Vector->new_Hex(8,'00');
$df = Bit::Vector->new_Hex(8,'00');
$e0 = Bit::Vector->new_Hex(8,'D8');

$hi1 = Bit::Vector->new_Hex(8,'00');
$hi2 = Bit::Vector->new_Hex(8,'28'); 

$carrybit = 0;
$overflow = 0;



my $fn = @ARGV[0];


if (open (FH, "<$fn"))
{
 undef $/;
 my $buffer = <FH>;
 $/ = "\n";
 close FH;

 for (my $x=1;$x<length($buffer);$x = $x + 2)
 {
  my $v1 = Bit::Vector->new_Dec(8,ord(substr($buffer,$x,1)))->to_Hex;
  my $v2 = Bit::Vector->new_Dec(8,ord(substr($buffer,$x+1,1)))->to_Hex;

  &two_into_three($v1,$v2);
 }
}
else
{
 die "could not open $fn";
}










#for (my $cn=0;$cn < @input;$cn = $cn + 2)
#{
# &two_into_three($input[$cn],$input[$cn+1]);
#}

print "\n";


sub two_into_three
{
 my ($v1,$v2) = @_;

# $dd = Bit::Vector->new_Dec(8,$v2);
# $de = Bit::Vector->new_Dec(8,$v1);

 $dd = Bit::Vector->new_Hex(8,$v2);
 $de = Bit::Vector->new_Hex(8,$v1);

 my $chars = '';
 

my %table = ( 
'12E9' => '9',
'12EA' => '?',
'12EB' => '!',
'12EC' => '2',
'12ED' => ' ',
'12EE' => '"',
'12EF' => '\'',
'12F0' => '<',
'12F1' => '>',
'12F2' => '/',
'12F3' => '0',
'12F4' => '3',
'12F5' => 'A',
'12F6' => 'B',
'12F7' => 'C',
'12F8' => 'D',
'12F9' => 'E',
'12FA' => 'F',
'12FB' => 'G',
'12FC' => 'H',
'12FD' => 'I',
'12FE' => 'J',
'12FF' => 'K',
'1300' => 'L',
'1301' => 'M',
'1302' => 'N',
'1303' => 'O',
'1304' => 'P',
'1305' => 'Q',
'1306' => 'R',
'1307' => 'S',
'1308' => 'T',
'1309' => 'U',
'130A' => 'V',
'130B' => 'W',
'130C' => 'X',
'130D' => 'Y',
'130E' => 'Z',
'130F' => '-',
'1310' => ',',
'1311' => '.' );






 for (my $cnt = 0;$cnt <3;$cnt++)
 {
  $db = Bit::Vector->new_Hex(8,'00');
  $dc = Bit::Vector->new_Hex(8,'00');

#  $carrybit = 0;


  for (my $x = 17;$x > 0;$x--)
  {
   $carrybit = $de->shift_left($carrybit);
   $carrybit = $dd->shift_left($carrybit);

   unless ($x == 1) 
   { 

    $a->from_Hex('0');

    if ($carrybit) { $a->from_Hex('1'); }
 
    $carrybit = $dc->shift_left(0);

    $carrybit = $db->shift_left($carrybit);

    ($carrybit,$overflow) = $a->add($a,$dc,$carrybit);

    ($carrybit,$overflow) = $a->subtract($a,$hi2,$carrybit);

    $e0 = $a->Clone();

    $a = $db->Clone();

    ($carrybit,$overflow) = $a->subtract($hi1,$a,$carrybit); 
 
    $df = $a->Clone();

    if ($carrybit)
    {
     $a = $df->Clone();
     $b = $e0->Clone();

     my $d = Bit::Vector->new_Bin(16,$a->to_Bin() . $b->to_Bin);

     my $hi = Bit::Vector->new_Bin(16,$hi1->to_Bin() . $hi2->to_Bin);


     ($carrybit,$overflow) = $d->add($d,$hi,0);
  

     $a->from_Bin(substr($d->to_Bin(),0,8));
     $b->from_Bin(substr($d->to_Bin(),8,8));

     $db = $a->Clone();
     $dc = $b->Clone();

    }
    else
    {
     $db = $df->Clone();
     $dc = $e0->Clone();
    }

    if ($carrybit) 
    {
     $carrybit = 0;
    }
    else
    {
     $carrybit = 1;
    }

#   &dump;
   }
  }   
 

  my $base = Bit::Vector->new_Hex(16,'12EA');
  my $d = Bit::Vector->new_Bin(16,$db->to_Bin() . $dc->to_Bin);
  $d->add($d,$base,$carrybit);

#  print $d->to_Hex();

#  print "  ";

#  print $table{$d->to_Hex()};

  $a = Bit::Vector->new_Dec(8,ord($table{$d->to_Hex()}));

#print $a->to_Hex();
#print "\n";

  $chars = $table{$d->to_Hex()} . $chars;
 }

 print "$chars";
}



sub dump
{
 print 'db=' . $db->to_Hex() . ' dc=' . $dc->to_Hex();

 print ' dd=' . $dd->to_Hex() . " de=" . $de->to_Hex();

 print ' df=' . $df->to_Hex() . " e0=" . $e0->to_Hex();

 print '  a=' . $a->to_Hex() . ' b=' . $b->to_Hex();

 print ' c=' . $carrybit . ' o=' . $overflow;

 print "\n";
}
